Index: /palm/trunk/SCRIPTS/.palm.config.atosb
===================================================================
--- /palm/trunk/SCRIPTS/.palm.config.atosb	(revision 4569)
+++ /palm/trunk/SCRIPTS/.palm.config.atosb	(revision 4570)
@@ -26,5 +26,5 @@
 %compiler_options    -fpe0 -O3 -fp-model source -ftz -xCORE-AVX512 -no-prec-div -no-prec-sqrt -ip -convert little_endian -I /sw/dataformats/netcdf/intel.18/4.7.3/skl/include/ -I /sw/numerics/fftw3/impi/intel/3.3.8/skl/include/
 %linker_options      -Wl,-rpath=\\$LD_RUN_PATH \\`nf-config --flibs\\` -L /sw/numerics/fftw3/impi/intel/3.3.8/skl/lib -lfftw3
-%module_commands     module use /sw/modules/HLRN; module load HLRNenv sw.skl slurm intel/18.0.6 impi/2018.5 netcdf-parallel/impi/intel fftw3/impi/intel
+%module_commands     module use /sw/modules/HLRN; module purge; module load HLRNenv sw.skl slurm intel/18.0.6 impi/2018.5 netcdf-parallel/impi/intel fftw3/impi/intel
 %execute_command     srun --propagate=STACK --kill-on-bad-exit -n {{mpi_tasks}} -N {{nodes}} --ntasks-per-node={{tasks_per_node}}  palm
 %execute_command_for_combine   srun --propagate=STACK -n 1 --ntasks-per-node=1  combine_plot_fields.x
Index: /palm/trunk/SCRIPTS/.palm.config.atosb_debug
===================================================================
--- /palm/trunk/SCRIPTS/.palm.config.atosb_debug	(revision 4569)
+++ /palm/trunk/SCRIPTS/.palm.config.atosb_debug	(revision 4570)
@@ -26,5 +26,5 @@
 %compiler_options    -fpe0 -check -check nooutput_conversion -check noarg_temp_created -traceback -g -O0 -align all -ftz -xCORE-AVX512 -no-prec-div -no-prec-sqrt -ip -convert little_endian -I /sw/dataformats/netcdf/intel.18/4.7.3/skl/include/ -I /sw/numerics/fftw3/impi/intel/3.3.8/skl/include/
 %linker_options      -Wl,-rpath=\\$LD_RUN_PATH \\`nf-config --flibs\\` -L /sw/numerics/fftw3/impi/intel/3.3.8/skl/lib -lfftw3
-%module_commands     module use /sw/modules/HLRN; module load HLRNenv sw.skl slurm intel/18.0.6 impi/2018.5 netcdf-parallel/impi/intel fftw3/impi/intel
+%module_commands     module use /sw/modules/HLRN; module purge; module load HLRNenv sw.skl slurm intel/18.0.6 impi/2018.5 netcdf-parallel/impi/intel fftw3/impi/intel
 %execute_command     srun --propagate=STACK --kill-on-bad-exit -n {{mpi_tasks}} -N {{nodes}} --ntasks-per-node={{tasks_per_node}}  palm
 %execute_command_for_combine   srun --propagate=STACK -n 1 --ntasks-per-node=1  combine_plot_fields.x
Index: /palm/trunk/SCRIPTS/.palm.config.atosg
===================================================================
--- /palm/trunk/SCRIPTS/.palm.config.atosg	(revision 4569)
+++ /palm/trunk/SCRIPTS/.palm.config.atosg	(revision 4570)
@@ -26,5 +26,5 @@
 %compiler_options    -fpe0 -O3 -fp-model source -ftz -xCORE-AVX512 -no-prec-div -no-prec-sqrt -ip -convert little_endian -I /sw/dataformats/netcdf/4.6.3/skl/intel.18_mpi/include -I /home/bekklaus/opt/fftw3_intel18/include
 %linker_options      -Wl,-rpath=\\$LD_RUN_PATH \\`nf-config --flibs\\` -L/home/bekklaus/opt/fftw3_intel18/lib -lfftw3
-%module_commands     module use /sw/modules/HLRN; module load HLRNenv sw.skl slurm intel/18.0.5 impi/2018.4 netcdf/4.6.3_intel.18_impi
+%module_commands     module use /sw/modules/HLRN; module purge; module load HLRNenv sw.skl slurm intel/18.0.5 impi/2018.4 netcdf/4.6.3_intel.18_impi
 %execute_command     srun --propagate=STACK --kill-on-bad-exit -n {{mpi_tasks}} -N {{nodes}} --ntasks-per-node={{tasks_per_node}}  palm
 %execute_command_for_combine   srun --propagate=STACK -n 1 --ntasks-per-node=1  combine_plot_fields.x
Index: /palm/trunk/SCRIPTS/.palm.config.atosg_debug
===================================================================
--- /palm/trunk/SCRIPTS/.palm.config.atosg_debug	(revision 4569)
+++ /palm/trunk/SCRIPTS/.palm.config.atosg_debug	(revision 4570)
@@ -26,5 +26,5 @@
 %compiler_options    -fpe0 -check -check nooutput_conversion -traceback -g -O0 -align all -ftz -xCORE-AVX512 -no-prec-div -no-prec-sqrt -ip -convert little_endian -I /sw/dataformats/netcdf/4.6.3/skl/intel.18_mpi/include -I /home/bekklaus/opt/fftw3_intel18/include
 %linker_options      -Wl,-rpath=\\$LD_RUN_PATH \\`nf-config --flibs\\` -L/home/bekklaus/opt/fftw3_intel18/lib -lfftw3
-%module_commands     module use /sw/modules/HLRN; module load HLRNenv sw.skl slurm intel/18.0.5 impi/2018.4 netcdf/4.6.3_intel.18_impi
+%module_commands     module use /sw/modules/HLRN; module purge; module load HLRNenv sw.skl slurm intel/18.0.5 impi/2018.4 netcdf/4.6.3_intel.18_impi
 %execute_command     srun --propagate=STACK --kill-on-bad-exit -n {{mpi_tasks}} -N {{nodes}} --ntasks-per-node={{tasks_per_node}}  palm
 %execute_command_for_combine   srun --propagate=STACK -n 1 --ntasks-per-node=1  combine_plot_fields.x